<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useLoadingStore } from '@/stores/loading'
import { useUserStore } from '@/stores/user'
import { ref, onMounted, nextTick, computed } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import type { VForm } from 'vuetify/components'

const userStore = useUserStore()
const authStore = useAuthStore()

const strUser = localStorage.getItem('user')
const parsedUser = strUser ? JSON.parse(strUser) : {}

const nowId = computed(() => parsedUser.id)
const nowName = computed(() => parsedUser.fullName)
const nowEmail = computed(() => parsedUser.email)
const nowImage = computed(() => parsedUser.image)
const nowGen = computed(() => parsedUser.gender)

// const nowId = ref(0)
// const nowName = ref('')
// const nowRole = ref('')
// const nowEmail = ref('')
// const nowImage = ref('')
// const nowGen = ref('')
const router = useRouter()
const route = useRoute()
const loading = ref()
const errorDialog = ref(false)
const type = ref('password')
const refform = ref<VForm | null>(null)
const form = ref(false)
const dialog = ref(false)
const loadingStore = useLoadingStore()
function saveSettings() {
  if (password.value != '' || passwordCon.value != '') {
    if (password.value === passwordCon.value) {
      userStore.editedUser.password = password.value
      userStore.saveUserByNow(nowId.value)
      closeDialog()
      authStore.logout()
      loadingStore.finish()
      return
    } else {
      errorDialog.value = true
    }
  }
  userStore.saveUserByNow(nowId.value)
  closeDialog()
  authStore.logout()
}

function changeType() {
  if (type.value == 'password') {
    type.value = ''
  } else {
    type.value = 'password'
  }
}

function closeError() {
  errorDialog.value = false
}

function onSubmit() {}
function uploadProfile() {
  dialog.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(async () => {
    userStore.clearForm()
    await userStore.getUser(nowId.value)
  })
}
async function savePicture() {
  userStore.saveUserByNow(nowId.value)
  closeDialog()
  authStore.logout()
  // refreshPage()
}

function refreshPage() {
  window.location.reload()
}

const password = ref('')
const passwordCon = ref('')

onMounted(async () => {
  try {
    if (strUser) {
      await userStore.getUser(nowId.value)
    }
  } catch (error) {
    console.error('Error parsing user data:', error)
  }
})
</script>

<template>
  <v-toolbar flat style="background-color: #282828; color: white">
          <v-toolbar-title>SETTING</v-toolbar-title>
          </v-toolbar>
  <v-container>
    <div class="wrapper" tabindex="0">
      <div class="menu-container">
        <v-row>
          <v-col
            ><button class="avatar-button" @click="uploadProfile()" rounded>
              <v-avatar
                class="list-item-hover"
                :image="'http://localhost:3000/images/users/' + nowImage"
                size="400"
                style="margin-right: 0px"
              ></v-avatar></button
          ></v-col>
          <v-col style="margin-top: 0%"
            ><div class="menu-item">
              <v-row>
                <v-col>
                  New Password
                  <div>
                    <v-text-field
                      prepend-inner-icon="mdi-lock-outline"
                      append-inner-icon="mdi-eye-outline"
                      @click:append-inner="changeType()"
                      @keydown.enter="saveSettings()"
                      v-model="password"
                      :readonly="loading"
                      :rules="[
                        (v) =>
                          (v && v.length >= 8) ||
                          'Password must contain letters and numbers more than 8 characters'
                      ]"
                      label="Password"
                      :type="type"
                      clearable
                      height="5px"
                    ></v-text-field>
                  </div>
                </v-col>
                <v-col>
                  Confirm Password
                  <div>
                    <v-text-field
                      prepend-inner-icon="mdi-lock-outline"
                      append-inner-icon="mdi-eye-outline"
                      @click:append-inner="changeType()"
                      @keydown.enter="saveSettings()"
                      :type="type"
                      v-model="passwordCon"
                      :readonly="loading"
                      :rules="[
                        (v) =>
                          (v && v.length >= 8) ||
                          'Password must contain letters and numbers more than 8 characters'
                      ]"
                      clearable
                      height="5px"
                      label="Confirm Password"
                    ></v-text-field>
                  </div>
                </v-col>
              </v-row>
            </div>
            <div class="menu-item">
              Change Name | Current Name : <span style="color: orange">{{ nowName }}</span>
              <div>
                <v-text-field
                  prepend-inner-icon="mdi-newspaper-variant-multiple-outline"
                  @keydown.enter="saveSettings()"
                  clearable
                  v-model="userStore.editedUser.fullName"
                  :readonly="loading"
                  height="5px"
                  label="Fullname"
                ></v-text-field>
              </div>
            </div>
            <div class="menu-item">
              Change Email | Current Email :
              <span style="color: orange">{{ nowEmail }}</span> Gender :
              <span style="color: orange">{{ nowGen }}</span>
              <v-row>
                <v-col cols="12" sm="12" md="8">
                  <v-text-field
                    v-model="userStore.editedUser.email"
                    :readonly="loading"
                    prepend-inner-icon="mdi-email"
                    @keydown.enter="saveSettings()"
                    clearable
                    height="5px"
                    label="Email"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-combobox
                    v-model="userStore.editedUser.gender"
                    :readonly="loading"
                    prepend-inner-icon="mdi-gender-male-female"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'Male', value: 'male' },
                      { title: 'Female', value: 'female' },
                      { title: 'Others', value: 'others' }
                    ]"
                    label="Gender"
                    :return-object="false"
                  ></v-combobox>
                </v-col>
              </v-row>
            </div>
            <div class="menu-item">
              Confirm Change
              <div>
                <v-btn
                  class="list-item-hover"
                  color="primary"
                  width="550px"
                  @click="saveSettings()"
                >
                  Save
                </v-btn>
              </div>
            </div></v-col
          >
        </v-row>
      </div>
    </div>
  </v-container>

  <v-dialog v-model="dialog" persistent width="600">
    <v-card>
      <v-card-title>
        <span class="text-h5">Upload Profile Picture</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="12">
                <v-img
                  :src="'http://localhost:3000/images/users/' + nowImage"
                  width="500"
                  height="360"
                ></v-img>
              </v-col>
              <v-col cols="12" sm="12" md="12">
                <v-file-input
                  v-model="userStore.editedUser.files"
                  :rules="[
                    (value) => {
                      return (
                        !value ||
                        !value.length ||
                        value[0].size < 5000000 ||
                        'Avatar size should be less than 5 MB!'
                      )
                    }
                  ]"
                  accept="image/png, image/jpeg"
                  label="Avatar"
                  placeholder="Pick an avatar"
                  prepend-icon="mdi-camera"
                ></v-file-input>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
        <v-btn color="primary" variant="text" @click="savePicture()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="errorDialog" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Error</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        You put incorrect password.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeError()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped>
.menu-container {
  display: flex;
  flex-direction: column;
}

.avatar-button {
  padding: 0;
  border: none;
  background: none;
  cursor: pointer; /* Add cursor pointer to indicate clickability */
}

.avatar-button:focus {
  outline: none; /* Remove focus outline */
}

.wrapper {
  display: flex;
  padding: 0;
  flex-direction: column;
  justify-content: center;
  margin-top: 12%;
  margin-left: -100px;
  margin-bottom: 0%;
}

.menu-item {
  width: 600px;
  max-height: 400px;
  background-color: #403c3c;
  color: white;
  border-radius: 8px;
  border: 0.16em solid black;
  text-align: center;
  padding: 8px;
  margin-bottom: 4px;
  margin-left: 0px;
  white-space: nowrap;

  transform-origin: 0 0;
  transform: translateX(-100px);
  opacity: 0;

  transition-property: transform, opacity;
  transition-duration: 1s;
  transition-timing-function: ease;
}

.wrapper:is(:hover, :focus) .menu-item {
  transform: translateX(0);
  opacity: 100%;
}

.wrapper .menu-item:nth-of-type(1) {
  transition-delay: 0ms;
}

.wrapper .menu-item:nth-of-type(2) {
  transition-delay: 100ms;
}

.wrapper .menu-item:nth-of-type(3) {
  transition-delay: 200ms;
}

.wrapper .menu-item:nth-of-type(4) {
  transition-delay: 300ms;
}

.wrapper .menu-item:nth-of-type(5) {
  transition-delay: 400ms;
}

.wrapper p {
  font-weight: bold;
  margin-bottom: -60px;
}

.list-item-hover {
  transition:
    transform 0.2s ease,
    box-shadow 0.2s ease; /* Add transitions for smoother animation */
}

.list-item-hover:hover {
  transform: scale(1.05); /* Increase size by 5% on hover */
  box-shadow:
    0 4px 6px rgba(0, 0, 0, 0.1),
    0 1px 3px rgba(0, 0, 0, 0.08); /* Add a subtle box shadow */
}
</style>
